---
title: Block formatting context
slug: Web/Guide/CSS/Block_formatting_context
tags:
  - CSS
  - Guide
  - NeedsBeginnerUpdate
  - NeedsExample
  - Reference
  - Web
---
<div>{{ CSSRef }}</div>

<p>A <strong>block formatting context</strong> is a part of a visual CSS rendering of a web page. It's the region in which the layout of block boxes occurs and in which floats interact with other elements.</p>

<p>A block formatting context is created by at least one of the following:</p>

<ul>
 <li>The root element of the document (<code>&lt;html&gt;</code>).</li>
 <li>Floats (elements where {{ cssxref("float") }} isn't <code>none</code>).</li>
 <li>Absolutely positioned elements (elements where {{ cssxref("position") }} is <code>absolute</code> or <code>fixed</code>).</li>
 <li>Inline-blocks (elements with {{ cssxref("display") }}<code>: inline-block</code>).</li>
 <li>Table cells (elements with {{ cssxref("display") }}<code>: table-cell</code>, which is the default for HTML table cells).</li>
 <li>Table captions (elements with {{ cssxref("display") }}<code>: table-caption</code>, which is the default for HTML table captions).</li>
 <li>Anonymous table cells implicitly created by the elements with {{ cssxref("display") }}<code>: table</code>, <code>table-row</code>, <code>table-row-group</code>, <code>table-header-group</code>, <code>table-footer-group</code> (which is the default for HTML tables, table rows, table bodies, table headers, and table footers, respectively), or <code>inline-table</code>.</li>
 <li>Block elements where {{ cssxref("overflow") }} has a value other than <code>visible</code> and <code>clip</code>.</li>
 <li>{{ cssxref("display") }}<code>: <a href="https://drafts.csswg.org/css-display/#valdef-display-flow-root">flow-root</a></code>.</li>
 <li>Elements with {{ cssxref("contain") }}<code>: layout</code>, <code>content</code>, or <code>paint</code>.</li>
 <li>Flex items (direct children of the element with {{ cssxref("display") }}<code>: flex</code> or <code>inline-flex</code>) if they are neither <a href="/en-US/docs/Glossary/Flex_Container">flex</a> nor <a href="/en-US/docs/Glossary/Grid_Container">grid</a> nor <a href="/en-US/docs/Web/CSS/CSS_Table">table</a> containers themselves.</li>
 <li>Grid items (direct children of the element with {{ cssxref("display") }}<code>: grid</code> or <code>inline-grid</code>) if they are neither <a href="/en-US/docs/Glossary/Flex_Container">flex</a> nor <a href="/en-US/docs/Glossary/Grid_Container">grid</a> nor <a href="/en-US/docs/Web/CSS/CSS_Table">table</a> containers themselves.</li>
 <li>Multicol containers (elements where {{ cssxref("column-count") }} or {{ cssxref("column-width") }} isn't <code>auto</code>, including elements with <code>column-count: 1</code>).</li>
 <li>{{ cssxref("column-span") }}<code>: all</code> should always create a new formatting context, even when the <code>column-span: all</code> element isn't contained by a multicol container (<a href="https://github.com/w3c/csswg-drafts/commit/a8634b96900279916bd6c505fda88dda71d8ec51">Spec change</a>, <a href="https://bugs.chromium.org/p/chromium/issues/detail?id=709362">Chrome bug</a>).</li>
</ul>

<p>Formatting contexts affect layout, but typically, we create a new block formatting context for the positioning and clearing floats rather than changing the layout, because an element that establishes a new block formatting context will:</p>

<ul>
 <li>contain internal floats.</li>
 <li>exclude external floats.</li>
 <li>suppress <a href="/en-US/docs/Web/CSS/CSS_Box_Model/Mastering_margin_collapsing">margin collapsing</a>.</li>
</ul>

<div class="notecard note">
<p>Note: a Flex/Grid container({{ cssxref("display") }}: flex/grid/inline-flex/inline-grid) establishes a new Flex/Grid formatting context, which is similar to block formatting context except layout. There's no floating children avaliable inside a flex/grid container, but exclude external floats and suppress margin collapsing still works.</p>
</div>

<h2 id="Examples">Examples</h2>

<h3 id="Contain_internal_floats">Contain internal floats</h3>

<div id="example1">
<p>Make float content and alongside content the same height.</p>

<p>Let's have a look at a couple of these in order to see the effect creating a new <abbr title="Block Formatting Context">BFC</abbr>.</p>

<p>In the following example, we have a floated element inside a <code>&lt;div&gt;</code> with a <code>border</code> applied. The content of that <code>&lt;div&gt;</code> has floated alongside the floated element. As the content of the float is taller than the content alongside it, the border of the <code>&lt;div&gt;</code> now runs through the float. As explained in the <a href="/en-US/docs/Web/CSS/CSS_Flow_Layout/In_Flow_and_Out_of_Flow">guide to in-flow and out of flow elements</a>, the float has been taken out of flow so the <code>background</code> and <code>border</code> of the <code>&lt;div&gt;</code> only contain the content and not the float.</p>

<p><strong>using <code>overflow: auto</code></strong></p>

<p>Setting <code>overflow: auto</code> or set other values than the initial value of <code>overflow: visible</code> created a new <abbr title="Block Formatting Context">BFC</abbr> containing the float. Our <code>&lt;div&gt;</code> now becomes a mini-layout inside our layout. Any child element will be contained inside it.</p>

<p>The problem with using <code>overflow</code> to create a new <abbr title="Block Formatting Context">BFC</abbr> is that the <code>overflow</code> property is meant for telling the browser how you want to deal with overflowing content. There are some occasions in which you will find you get unwanted scrollbars or clipped shadows when you use this property purely to create a <abbr title="Block Formatting Context">BFC</abbr>. In addition, it is potentially not readable for a future developer, as it might not be obvious why you used <code>overflow</code> for this purpose. If you use <code>overflow</code>, it is a good idea to comment the code to explain.</p>

<p><strong>using <code>display: flow-root</code></strong></p>

<p>A newer value of <code>display</code> lets us create a new <abbr title="Block Formatting Context">BFC</abbr> without any other potentially problematic side-effects. Using <code>display: flow-root</code> on the containing block creates a new <abbr title="Block Formatting Context">BFC</abbr> .</p>

<p>With <code>display: flow-root;</code> on the <code>&lt;div&gt;</code>, everything inside that container participates in the block formatting context of that container, and floats will not poke out of the bottom of the element.</p>

<p>The value name of <code>flow-root</code> makes sense when you understand you are creating something that acts like the <code>root</code> element (<code>&lt;html&gt;</code> element in browser) in terms of how it creates a new context for the flow layout inside it.</p>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;section&gt;
    &lt;div class="box"&gt;
        &lt;div class="float"&gt;I am a floated box!&lt;/div&gt;
        &lt;p&gt;I am content inside the container.&lt;/p&gt;
    &lt;/div&gt;
&lt;/section&gt;
&lt;section&gt;
    &lt;div class="box" style="overflow:auto"&gt;
        &lt;div class="float"&gt;I am a floated box!&lt;/div&gt;
        &lt;p&gt;I am content inside the &lt;code&gt;overflow:auto&lt;/code&gt; container.&lt;/p&gt;
    &lt;/div&gt;
&lt;/section&gt;
&lt;section&gt;
    &lt;div class="box" style="display:flow-root"&gt;
        &lt;div class="float"&gt;I am a floated box!&lt;/div&gt;
        &lt;p&gt;I am content inside the &lt;code&gt;display:flow-root&lt;/code&gt; container.&lt;/p&gt;
    &lt;/div&gt;
&lt;/section&gt;</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">section {
    height:150px;
}
.box {
    background-color: rgb(224, 206, 247);
    border: 5px solid rebeccapurple;
}
.box[style] {
    background-color: aliceblue;
    border: 5px solid steelblue;
}
.float {
    float: left;
    width: 200px;
    height: 100px;
    background-color: rgba(255, 255, 255, .5);
    border:1px solid black;
    padding: 10px;
}</pre>

<p>{{EmbedLiveSample("example1", 200, 450)}}</p>
</div>

<h3 id="Exclude_external_floats">Exclude external floats</h3>

<div id="example2">
<p>In the following example, we are using <code>display:flow-root</code> and floats to implement double columns layout, because an element in the normal flow that establishes a new <abbr title="Block Formatting Context">BFC</abbr> must not overlap the margin box of any floats in the same block formatting context as the element itself.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;section&gt;
  &lt;div class="float"&gt;Try to resize this outer float&lt;/div&gt;
  &lt;div class="box"&gt;&lt;p&gt;Normal&lt;/p&gt;&lt;/div&gt;
&lt;/section&gt;
&lt;section&gt;
  &lt;div class="float"&gt;Try to resize this outer float&lt;/div&gt;
  &lt;div class="box" style="display:flow-root"&gt;&lt;p&gt;&lt;code&gt;display:flow-root&lt;/code&gt;&lt;p&gt;&lt;/div&gt;
&lt;/section&gt;</pre>

<h4 id="CSS_2">CSS</h4>

<pre class="brush: css notranslate">section {
    height:150px;
}
.box {
    background-color: rgb(224, 206, 247);
    border: 5px solid rebeccapurple;
}
.box[style] {
    background-color: aliceblue;
    border: 5px solid steelblue;
}
.float {
    float: left;
    overflow: hidden; /* required by resize:both */
    resize: both;
    margin-right:25px;
    width: 200px;
    height: 100px;
    background-color: rgba(255, 255, 255, .75);
    border: 1px solid black;
    padding: 10px;
}
</pre>

<p>{{EmbedLiveSample("example2", 200, 300)}}</p>

<p>Rather than inline-blocks with width:&lt;percentage&gt;, in this case we don't have to specify the width of the right div.</p>

<p>Note that flexbox is a more efficient way to implement muti columns layout in modern CSS.</p>
</div>

<h3 id="Margin_collapsing">Margin collapsing</h3>

<p>Creating a new BFC to avoid the <a href="/en-US/docs/Web/CSS/CSS_Box_Model/Mastering_margin_collapsing">margin collapsing</a> between two neighbor div:</p>

<h4 id="HTML_3">HTML</h4>

<pre class="brush: html notranslate">&lt;div class="blue"&gt;&lt;/div&gt;
&lt;div class="red-outer"&gt;
  &lt;div class="red-inner"&gt;red inner&lt;/div&gt;
&lt;/div&gt;
</pre>

<h4 id="CSS_3">CSS</h4>

<pre class="brush: css notranslate">.blue, .red-inner {
  height: 50px;
  margin: 10px 0;
}

.blue {
  background: blue;
}

.red-outer {
  overflow: hidden;
  background: red;
}
</pre>

<p>{{EmbedLiveSample("Margin_collapsing", 120, 120)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Display', '#block-formatting-context', 'Block Formatting Context')}}</td>
   <td>{{Spec2('CSS3 Display')}}</td>
   <td>define BFC(abbr) etc.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'visuren.html#block-formatting', 'Block Formatting Context')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{ cssxref("float") }}, {{ cssxref("clear") }}</li>
 <li>{{css_key_concepts}}</li>
</ul>
